import math
import pickle
import numpy as np
from sklearn.svm import SVC
import random
from sklearn.ensemble import RandomForestClassifier
from sklearn.model_selection import GridSearchCV
def Iris_label(s):
    it = {b'0': 0, b'1': 1, b'2': 2, b'3':3,b'4':4}
    return it[s]

def getFinal(type00, n,max):
    if(n<=1):
       n=2
    list2 = []
    num = len(type00)
    bin_list = []
    for i in range(n):
        bin_list.append([])
    for i in range(len(type00)):
        list2.append(type00[i][0] * 0.299 + type00[i][1] * 0.587 + 0.114 * type00[i][2])
        bin_list[int(list2[i] / ((max+(n-1))/n))].append(type00[i])
    list_end = []
    for i in range(n):
        list3 = []
        for k in range((int(0.005* len(bin_list[i]) * len(bin_list[i]) / num))):
            n1 = len(bin_list[i]) - 1
            list3.append(random.randint(0, n1))
        for j in range(len(list3)):
            list_end.append(bin_list[i][list3[j]])
    return list_end#返回筛选后的样本
path=r"D:\saveF.txt"  #标记样本文件
SavePath = r"D:\modelF.pickle"#模型保存路径
#读取数据集
data = np.loadtxt(path, dtype=int, delimiter=',', converters={3: Iris_label})
data = data.tolist()
n = len(data)
list1 = [0] * 5#筛选前各地物样本数目
for i in range(len(data)):
    x = data[i][3]
    if (x == 0):
        list1[0] = list1[0] + 1
    elif (x == 1):
        list1[1] = list1[1] + 1
    elif (x == 2):
        list1[2] = list1[2] + 1
    elif (x == 3):
        list1[3] = list1[3] + 1
    elif (x == 4):
        list1[4] = list1[4] + 1
list5=[0]*5
data1=list(map(list,zip(*data)))
max0=0
min0=99999
for i in range(3):
    if(max0<max(data1[i])):
     max0=max(data1[i])
    if(min0>min(data1[i])):
        min0=min(data1[i])
bins_sum=math.sqrt(max0-min0+1)
for i in range(5):

    list5[i]=int(bins_sum*(list1[i]/len(data)+0.05))
count=[0]*5
m=0
n=list1[0]
sample0=data[0:list1[0]]
sample0=getFinal(sample0,list5[0],max0)
print(len(sample0))
for i in range(4):
    m=list1[i]+m
    n=m+list1[i+1]
    sample_h = data[m:n]
    sample_h = getFinal(sample_h, list5[i+1],max0)
    print(len(sample_h))
    sample = sample0 + sample_h
    sample0=sample
x, y = np.split(sample0, indices_or_sections=(3,), axis=1)
x = x[:, 0:3]
list1 = [0] * 5
path1 = r"D:\testF.txt"#测试样本数据
data1 = np.loadtxt(path1, dtype=int, delimiter=',', converters={3: Iris_label})
p, q = np.split(data1, indices_or_sections=(3,), axis=1)
p = p[:, 0:3]

list_acc = []

from sklearn.metrics import accuracy_score, precision_score, recall_score, f1_score,cohen_kappa_score
# 训练SVM模型
svm = SVC()

# 定义参数范围，可以根据你的需求进行修改
param_grid_svm = {
    'C':  [0.25, 0.50, 1, 2, 4, 8, 16, 32, 64, 128],  # 参数C的候选值
    'kernel': ['rbf'],  # 核函数的候选值v
    'gamma':[0.001, 0.01, 0.1, 1, 10, 100],  # gamma参数的候选值
}

# 使用GridSearchCV进行参数搜索和五折交叉验证
from sklearn.metrics import make_scorer, cohen_kappa_score
kappa_scorer = make_scorer(cohen_kappa_score)
grid_search_svm = GridSearchCV(estimator=svm, param_grid=param_grid_svm, scoring=kappa_scorer,cv=5)
grid_search_svm.fit(x, y.ravel())

# 输出最佳参数和对应的分数
print("SVM最佳参数：", grid_search_svm.best_params_)
print("SVM最佳分数：", grid_search_svm.best_score_)

from sklearn.neighbors import KNeighborsClassifier
from sklearn.model_selection import GridSearchCV

# 创建KNN分类器
knn = KNeighborsClassifier()

# 设置要调整的参数范围
param_grid_knn = {'n_neighbors': [1,3,5,7,9]}
# 创建GridSearchCV对象
grid_search_knn = GridSearchCV(knn, param_grid_knn, cv=5, scoring=kappa_scorer)

# 使用训练数据拟合GridSearchCV对象
grid_search_knn.fit(x, y.ravel())

# 打印最佳K值
print("KNN最佳K值:", grid_search_knn.best_params_)

# 打印最佳K值下的交叉验证准确率
print("最佳K值下的交叉验证准确率:", grid_search_knn.best_score_)
rf_model = RandomForestClassifier()
param_grid_rf = {
    'n_estimators': [10, 50, 100, 200],
    'max_features': [1,3,5,7,9]# 随机森林中的决策树数量

}

# 使用 GridSearchCV 来进行参数选择
grid_search_rf = GridSearchCV(rf_model, param_grid_rf, cv=5,scoring=kappa_scorer)
grid_search_rf.fit(x, y.ravel())
# 输出最优参数
print("RF最佳K值:", grid_search_rf.best_params_)

# 打印最佳K值下的交叉验证准确率
print("最佳RF值下的交叉验证准确率:", grid_search_rf.best_score_)


SVM_classifier = SVC(C=grid_search_svm.best_params_['C'], kernel='rbf', gamma=grid_search_svm.best_params_['gamma'])
SVM_classifier.fit(x,y.ravel())
q_pred = SVM_classifier.predict(p)
accuracy = accuracy_score(q.ravel(), q_pred)

print("SVM准确率  ", accuracy)

# 训练RF和KNN模型
for i in range(2):
    if (i == 1):
        classifier = KNeighborsClassifier(n_neighbors=grid_search_knn.best_params_['n_neighbors'])
        str="KNN"
    else:
        classifier = RandomForestClassifier(n_estimators=grid_search_rf.best_params_['n_estimators'],
                                            #random_state=0,
                                            # min_samples_leaf=10,
                                            #bootstrap=True,
                                            # min_samples_split=10,
                                           # max_features='sqrt',
                                            max_features=grid_search_rf.best_params_['max_features'],
                                           )

        str="rf"
    classifier.fit(x, y.ravel())

    q_pred = classifier.predict(p)
    accuracy = accuracy_score(q.ravel(), q_pred)
    ka = cohen_kappa_score(q.ravel(), q_pred)
    print(str,"准确率  ",accuracy)


file = open(SavePath, "wb")
# 将RF模型写入文件：
pickle.dump(SVM_classifier, file)
# 最后关闭文件：
file.close()
